/*!
 * @file gui_element.h
 *  Definition of ...

*/

#ifndef _GUI_ELEMENT_H
#define _GUI_ELEMENT_H

#include "gui_saveable.h"

namespace OrxGui
{
  class Widget;

  //! A SuperClass for all the Different GuiElements
  class GuiElement : public GuiSaveableGroup
  {

  public:
    GuiElement(const std::string& name);
    virtual ~GuiElement();

    /** @returns the main Widget of this GuiElement. */
    Widget* getWidget() const { return this->mainWidget; }
  protected:
    void setMainWidget(Widget* widget);

  private:
    Widget* mainWidget;
  };
}
#endif /* _GUI_ELEMENT_H */
