/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_

#include "gui_saveable.h"

namespace OrxGui
{

  /**
   * standard constructor
  */
  GuiSaveable::GuiSaveable (const std::string& optionName)
  {
    this->bSaveable = false;
  }


  /**
   * standard deconstructor
  */
  GuiSaveable::~GuiSaveable ()
  {
    // delete what has to be deleted here
  }


  void GuiSaveable::makeSaveable()
  {
    this->bSaveable = true;

  }


  GuiSaveableGroup::GuiSaveableGroup(const std::string& groupName)
      : GuiSaveable(groupName)
  {
    //    this->setName(groupName);
  }




  GuiSaveableGroup::~GuiSaveableGroup()
  {
    std::vector<GuiSaveableGroup*>::iterator delGroup = std::find(saveableGroups.begin(), saveableGroups.end(), this);

    if (delGroup != saveableGroups.end() )
      saveableGroups.erase(delGroup);
  }

  std::vector<GuiSaveableGroup*>  GuiSaveableGroup::saveableGroups;

  void GuiSaveableGroup::makingElementSaveable()
  {
    GuiSaveableGroup::saveableGroups.push_back(this);
  }


}
